#ifndef _KEYS_H
#define _KEYS_H

#include <string.h>
#include <openssl/rsa.h>


typedef enum _keytypes 
{
    KEYS_PUBKEY=1,
    KEYS_PRIVKEY=2,
} KEYS_KEYTYPE;

int keys_gen_symmetric_key(void **keybuf,
                           size_t keylength);

int keys_free_symmetric_key(void *keybuf);

int keys_gen_rsa_key(RSA **rsa_key,
                     size_t size);

int keys_set_rsa_pubkey_by_mod_e(RSA **rsa_key,
                                 const char *mod,
                                 const char *exp);

int keys_free_rsa_key(RSA *rsa_key);

int keys_rsakey2file(const char *filename,
                     KEYS_KEYTYPE key_type,
                     RSA *rsa_key);

int keys_file2rsakey(RSA **rsa_key,
                     const char *filename,
                     KEYS_KEYTYPE key_type);

#endif
