#ifndef _UTILS_H
#define _UTILS_H

#include <stdio.h>
#include <string.h>

int utils_pad(void *dst,
              size_t dst_size,
              const void *src,
              size_t src_len,
              unsigned char pad,
              size_t total_len);

int utils_xor(void *dst,
              size_t dst_size,
              const void *x1,
              const void *x2);

void utils_append(void *dst,
                  size_t dst_size,
                  const void *x1,
                  size_t x1_len,
                  const void *x2,
                  size_t x2_len);

void utils_dumphex(const void *src,
                   size_t src_len);

int utils_binstr2bin(unsigned char *bin,
                     size_t bin_size,
                     const char *binstr,
                     size_t binstr_length);

int utils_bstrenc2bin(unsigned char *bin,
                      size_t bin_size,
                      size_t *bin_length,
                      const char *binstr,
                      unsigned int index);

int utils_bstrenc2str(char *str,
                      size_t str_size,
                      size_t *str_length,
                      const char *binstr,
                      unsigned int index);

int utils_bin2str(unsigned char *str,
                  size_t str_size,
                  const unsigned char *bin,
                  size_t bin_len);

int utils_str2bin(unsigned char *bin,
                  size_t bin_size,
                  size_t *bin_len,
                  const char *str);

int utils_print_lic(FILE *f,
                    const unsigned char *str);

#endif
