// base_stream.h
// Example and test file to illustrate how to use the factory template.
// This file represents the stream-based I/O for saving & restoring
// objects derived from Base.
// Copyright 2001, 2003 Jim Hyslop.
//
// This file may be freely used, modified and distributed, provided that
// the accompanying copyright notice remains intact.
//
// $Id: base_stream.h,v 1.6 2003/03/10 03:30:44 Jim Exp $

#ifndef BASE_PERSISTENCE_USING_STREAMS_HDEADER
#define BASE_PERSISTENCE_USING_STREAMS_HDEADER

#include "factory.h"
#include "base.h"
#include <boost/shared_ptr.hpp>
#include <iosfwd>
#include <memory>
#include <string>

typedef std::auto_ptr< Base > (* BaseStreamRestoreFn)( std::istream & ); 
typedef void (*BaseStreamSaveFn)( std::ostream &, const Base::BaseParams & );

typedef GenericFactory< 
        Base, 
        std::string, 
        std::istream, 
        std::ostream,
        Base::BaseParams, 
        BaseStreamRestoreFn,
        BaseStreamSaveFn
        > 
BaseFactoryUsingStreams;


void saveOutputFile(std::ostream & output, 
                    std::vector< boost::shared_ptr< Base > > &loadedClasses);

void loadInputFile(std::istream & input,
                   std::vector< boost::shared_ptr< Base > > &loadedClasses);

#endif
