// file: derived.cpp
// Implementation of derived class.
// Copyright 2001, 2003 Jim Hyslop.
//
// This file may be freely used, modified and distributed, provided that
// the accompanying copyright notice remains intact.
//
// $Id: derived.cpp,v 1.16 2003/04/02 03:44:32 Jim Exp $

// Rule: first file included should be the one containing the class
// definition (See "Large Scale C++ programming", John Lakos)
#include "derived.h" 

#include <iostream>

using namespace std;

Base::BaseKeyType Derived::classID() const
{
    return derivedClassID();
}

Base::BaseKeyType Derived::derivedClassID()
{
    return "Derived";
}

Derived::Derived( int baseValue, const string & word )
: Base( baseValue ),
  word_( word )
{
}

Derived::Derived( const DerivedParams & params )
: Base( params ), word_( params.word_ )
{
}

auto_ptr< Base::BaseParams > Derived::createStorageInfo() const
{
    return auto_ptr< BaseParams >( new DerivedParams );
}

void Derived::setStorageValues( BaseParams & bp ) const
{
    Base::setStorageValues( bp );
    DerivedParams & dp = static_cast< DerivedParams &>( bp );
    dp.word_ = word_;
}

void Derived::displayValues()
{
    cout << "Hi, I'm a Derived, and my string is " << word_;
    cout << "\n\tMy parent says:";
    Base::displayValues();
}
