// file: ui.cpp
// User interface for creation of new objects
// Copyright 2003 Jim Hyslop.
//
// This file may be freely used, modified and distributed, provided that
// the accompanying copyright notice remains intact.
//
// $Id: ui.cpp,v 1.3 2003/03/10 01:58:05 Jim Exp $
#include "Derived.h"
#include "factory.h"
#include <memory>
#include <iostream>

using namespace std;

namespace {
    auto_ptr< Base > createBase() 
    {
        int value;
        std::cout << "Enter a number for Base: ";
        std::cin >> value;
        return auto_ptr<Base>( new Base( value ) );
    }
    bool registerBaseCreator()
    {
        GenericFactory<Base, Base::BaseKeyType>::instance().registerFunctions( Base::baseClassID(), createBase );
        return true;
    }
    bool dummyForBaseCreation = registerBaseCreator();

    auto_ptr< Base > createDerived() 
    {
        int value;
        std::cout << "Enter a number for Base: ";
        std::cin >> value;

        string word;
        cout << "Enter a word: ";
        cin >> word;
        return auto_ptr< Base >( new Derived( value, word ) );
    }
    bool registerDerivedCreator()
    {
        GenericFactory<Base, Base::BaseKeyType>::instance().registerFunctions( Derived::derivedClassID(), createDerived );
        return true;
    }
    bool dummyForDerivedCreation = registerDerivedCreator();
}
